'Phone and Address Book for multiple users
    open "phonebook\users.dat" for append as #k
        if lof(#k) = 0 then print #k, 0
    close #k
    nomainwin

    WindowWidth = 428
    WindowHeight = 270
    UpperLeftX = int((DisplayWidth-WindowWidth)/2)
    UpperLeftY = int((DisplayHeight-WindowHeight)/2)
    a$ = "Name,Phone 1,Phone 2,E-mail,WWW,Address,City,Post Code"


    for x = 1 to 8
        dataType$(x-1) = word$(a$,x,",")
    next x
    x = 0
    graphicbox #main.menubar, -1, -1, 430, 32
    bmpbutton #main, "phonebook\user.bmp", [users], UL, 4,2
    statictext #main.dataType, "", 14, 40, 144, 20
    textbox #main.text, 14, 65, 176, 25
    button #main.back, "<<", [back], UL, 22, 100, 26, 25
    button #main.default, ">>", [forward], UL, 54, 100, 26, 25
    button #main.empty, "Empty", [empty], UL, 102, 100, 74, 25
    button #main.save, "Save", [save], UL, 22, 146, 74, 25
    button #main.search, "Search", [search], UL, 102, 146, 74, 25
    button #main.delete, "Delete", [delete], UL, 22, 181, 74, 25
    button #main.modify, "Modify", [modify], UL, 102, 181, 74, 25
    statictext #main.info, "", 230, 40, 264, 190
    open "Phone and Address Book" for dialog_nf as #main
    #main.menubar, "down; fill palegray; flush"
    #main, "trapclose [close]"
    print #main, "font ms_sans_serif 0 16"
    open "phonebook\users.dat" for input as #k
        input #k, a$
    close #k
    if word$(a$,1) = "1" then
        user$ = word$(a$,2)
        goto [skipLogin]
        end if
[login]
    WindowWidth = 192
    WindowHeight = 175
    UpperLeftX = 118
    UpperLeftY = 47

    textbox #login.name, 22, 36, 130, 25
    button #login, "Ok", [ok], UL, 46, 91, 88, 25
    open "Login / New User" for dialog_nf_modal as #login
    #login, "trapclose [ok]"
    print #login, "font ms_sans_serif 0 16"
    #login.name, "Username"
    wait

[ok]
    #login.name, "!contents? login$"
    if login$ = "" or login$ = "Username" then
        notice "Enter username."
        wait
        end if
    open "phonebook\users.dat" for input as #k
    input #k, a$
    loginFlag = 0
    while eof(#k) <> -1
        input #k, a$
        if a$ = login$ then
            user$ = login$
            loginFlag = 1
            exit while
            end if
        wend
    close #k
    if loginFlag = 1 then close #login : goto [skipLogin]
    confirm "Add new user?"; answer$
    if answer$ = "no" then wait
    open "phonebook\users.dat" for append as #k
    print #k, login$
    close #k
    user$ = login$
    notice "New user added."
    close #login

[skipLogin]
    open "phonebook\data"; user$; ".dat" for random as #f len=166
    field #f, 24 as name$, 16 as phone1$, 16 as phone2$, 30 as email$, 30 as www$,_
         24 as address$, 16 as city$, 10 as postcode$
[update]
    #main.text, data$(x)
    #main.text, "!setfocus"
    print #main.dataType, dataType$(x); ":"
    print #main.info, data$(0); chr$(13); chr$(13); data$(1);_
     chr$(13); data$(2); chr$(13); chr$(13); data$(3); chr$(13); data$(4); chr$(13); chr$(13);_
     data$(5); chr$(13); data$(6); chr$(13); data$(7)
    wait

[back]
    #main.text, "!contents? a$"
    data$(x) = a$
    x = x-1
    if x < 0 then x = 7
    goto [update]
[forward]
    #main.text, "!contents? a$"
    data$(x) = a$
    x = x+1
    if x > 7 then x = 0
    goto [update]
[empty]
    flag = 0
    redim data$(7)
    x = 0
    goto [update]
[save]
    if flag = 1 then notice "Press Modify to save modified entry.": wait
    #main.text, "!contents? a$"
    data$(x) = a$
    if data$(0) = "" then notice "Entry without name!": wait
    for a = 1 to (lof(#f))/166
        get #f, a
        if trim$(name$) = "" then exit for
    next a
    name$ = data$(0)
    phone1$ = data$(1)
    phone2$ = data$(2)
    email$ = data$(3)
    www$ = data$(4)
    address$ = data$(5)
    city$ = data$(6)
    postcode$ = data$(7)
    put #f, a
    notice name$; " has been saved."
    goto [empty]
[search]
    if flag = 1 then [continue]
    #main.text, "!contents? a$"
    if a$ = "" then notice "Enter search string!": wait
    if lof(#f) = 0 then notice "Database is empty!": wait
    a = 0
    a$ = lower$(a$)
[continue]
    flag = 0
    if a = lof(#f)/166 then [notFound]
    do
        a = a+1
        get #f, a
        if x = 0 and instr(lower$(name$), a$) > 0 then [found]
        if x = 1 and instr(phone1$, a$) > 0 then [found]
        if x = 2 and instr(phone2$, a$) > 0 then [found]
        if x = 3 and instr(lower$(email$), a$) > 0 then [found]
        if x = 4 and instr(lower$(www$), a$) > 0 then [found]
        if x = 5 and instr(lower$(address$), a$) > 0 then [found]
        if x = 6 and instr(lower$(city$), a$) > 0 then [found]
        if x = 7 and instr(lower$(postcode$), a$) > 0 then [found]
    loop until a = lof(#f)/166
[notFound]
    notice, "No match."
    redim data$(7)
    goto [update]

[found]
    flag = 1
    data$(0) = trim$(name$)
    data$(1) = trim$(phone1$)
    data$(2) = trim$(phone2$)
    data$(3) = trim$(email$)
    data$(4) = trim$(www$)
    data$(5) = trim$(address$)
    data$(6) = trim$(city$)
    data$(7) = trim$(postcode$)
    goto [update]
[delete]
    if flag = 0 then notice "First search for the entry to delete.": wait
    confirm "Really delete?"; answer$
    if answer$ = "no" then wait
    a$ = trim$(name$)
    name$ = ""
    phone1$ = ""
    phone2$ = ""
    email$ = ""
    www$ = ""
    address$ = ""
    city$ = ""
    postcode$ = ""
    put #f, a
    notice a$; " - entry deleted."
    flag = 0
    redim data$(7)
    goto [update]
[modify]
    #main.text, "!contents? a$"
    data$(x) = a$
    if flag = 0 then notice "First search for the entry to modify.": wait
    confirm "Save modified entry?"; answer$
    if answer$ = "no" then wait
    name$ = data$(0)
    phone1$ = data$(1)
    phone2$ = data$(2)
    email$ = data$(3)
    www$ = data$(4)
    address$ = data$(5)
    city$ = data$(6)
    postcode$ = data$(7)
    put #f, a
    notice name$; " - entry modified."
    flag = 0
    goto [update]

[users]

    WindowWidth = 224
    WindowHeight = 255
    UpperLeftX = 102
    UpperLeftY = 1
    open "phonebook\users.dat" for input as #k
    input #k, a$
    defaultSet = val(word$(a$, 1))
    defaultUser$ = word$(a$, 2)
    y = 0
    while eof(#k) <> -1
        y = y+1
        input #k, a$
    wend
    dim users$(y)
    close #k
    open "phonebook\users.dat" for input as #k
    input #k, a$
    y = 0
    while eof(#k) <> -1
        y = y+1
        input #k, a$
        users$(y) = a$
    wend
    close #k

    statictext #settings, "Default user:", 26, 16, 224, 20
    combobox #settings.combo1, users$(, [defaultUser], 22, 41, 160, 100
    checkbox #settings.check, "set", [defaultSet], [defaultReset], 22, 71, 88, 20
    statictext #settings, "Change user:", 22, 96, 128, 20
    combobox #settings.combo2, users$(, [newUser], 22, 131, 160, 105
    button #settings, "Ok", [settingOk], UL, 54, 176, 96, 25
    open "User settings" for dialog_nf_modal as #settings
    #settings, "trapclose [settingCancel]"
    print #settings, "font ms_sans_serif 0 16"
    #settings.combo1, "!"; defaultUser$
    if defaultSet = 1 then #settings.check, "set"
    wait
[defaultSet]
    defaultSet = 1
    wait
[defaultReset]
    defaultSet = 0
    wait
[defaultUser]
    #settings.combo1, "selection? defaultUser$"
    wait
[newUser]
    #settings.combo2, "selection? user$"
    close #f
    open "phonebook\data"; user$; ".dat" for random as #f len=166
    field #f, 24 as name$, 16 as phone1$, 16 as phone2$, 30 as email$, 30 as www$,_
         24 as address$, 16 as city$, 10 as postcode$
    wait
[settingOk]
    open "phonebook\users.dat" for output as #k
    a$ = defaultSet; " "; defaultUser$
    print #k, a$
    for index = 1 to y
        print #k, users$(index)
    next index
    close #k
[settingCancel]
    close #settings
    wait
[close]
    close #f
    close #main
    end
